eval(require('fs').readFileSync("parser.js", "utf8"))

console.log("parsing identity λ x → x: ", S(ps("λ x → x")).ast.toString())

console.log("parsing nested λ x → λ x → x x: ", S(ps("λ x → λ x → x x")).ast.toString())

console.log("parsing nested application (λ x → λ x → x x) y: ", S(ps("(λ x → λ x → x x) y")).ast.toString())

console.log("parsing (λ x → x) y, expecting (λ x → x) y: ", S(ps("(λ x → x) y")).ast.toString())

console.log("reducing (λ x → x) y, expecting y: ", S(ps("(λ x → x) y")).ast.reduce().toString())

console.log("reducing nested application (λ x → λ x → x x) y, expecting λ x → x x: ", S(ps("(λ x → λ x → x x) y")).ast.reduce().toString())

console.log("reducing nested application (λ x → λ y → x y) y, expecting λ #x1 → y #x1: ", S(ps("(λ x → λ y → x y) y")).ast.reduce().toString())

console.log("negation λ p → p (λ w → λ f → f) (λ w → λ f → w): ", S(ps("λ p → p (λ w → λ f → f) (λ w → λ f → w)")).ast.toString())
console.log("negate false, expect true: ", S(ps("(λ p → p (λ w → λ f → f) (λ w → λ f → w)) (λ w → λ f → f)")).ast.reduce().toString())

console.log("und (λ p → λ q → p q p): ", S(ps("λ p → λ q → p q p")).ast.toString())

console.log("und falsch falsch: ", S(ps("(λ p → λ q → p q p) (λ w → λ f → f) (λ w → λ f → f)")).ast.reduce().toString())

console.log("und2 λ p → λ q → q p q: ", S(ps("λ p → λ q → q p q")).ast.toString())

console.log("und2 falsch falsch: ", S(ps("(λ p → λ q → q p q) (λ w → λ f → f) (λ w → λ f → f)")).ast.reduce().toString())

console.log("iff wahr wahr falsch -> wahr: ", S(ps("(λ p → λ c → λ a → p c a) (λ w → λ f → w) (λ w → λ f → w) (λ w → λ f → f)")).ast.reduce().toString())

console.log("inkrement 0 -> eins: ", S(ps("(λ n → λ s → λ z → s (n s z)) (λ s → λ z → z)")).ast.reduce().toString())

console.log("(λ x -> λ y -> x y) (λ z -> y z) -> λ #x2 -> y #x2: ", S(ps("(λ x → λ y → x y) (λ z → y z)")).ast.reduce().toString())

console.log("(λ x -> λ y -> x y) (λ z -> a z) -> λ y -> a y: ", S(ps("(λ x → λ y → x y) (λ z → a z)")).ast.reduce().toString())



