eval(require('fs').readFileSync("parser.js", "utf8"))

showReductions = false

var pair = S(ps("λ x → (λ y → (λ z → z x y))")).ast
var fst = S(ps("λ p → p (λ x → λ y → x)")).ast
var snd = S(ps("λ p → p (λ x → λ y → y)")).ast

var wahr = S(ps("λ w → (λ f → w)")).ast
var nil = new Application(new Application(pair, wahr), wahr).reduce()
var offset = 32;

//console.log("pair ", pair.toString())
//console.log("fst ", fst.toString())
//console.log("snd ", snd.toString())
//console.log("nil ", nil.toString())

//var mypair = new Application(new Application(pair, S(ps("λ x → x")).ast), nil)
//console.log("mypair ", mypair.reduce().toString())
//console.log("fst mypair ", new Application(fst, mypair).reduce().toString())
//console.log("snd mypair ", new Application(snd, mypair).reduce().toString())

function mymap (fun, xs) {
  if (xs.length === 0)
    return [];
  return [fun.call(xs, xs[0], 0, xs)].concat(mymap(fun, xs.slice(1)));
}

function myReduceRight (f, init, arr) {
  var acc = init;
  for (var i = arr.length - 1; i >= 0; i--) {
    var item = arr[i];
    acc = f(item,acc);
  }
  return acc;
}

function toPair (a, b) {
  return new Application(new Application(pair, a), b).reduce()
}

//var mypair2 = toPair(toChurch(3), nil).reduce()
//console.log("pair(3, nil): ", mypair2.toString())
//console.log("fst pair(3, nil): ", new Application(fst, mypair2).reduce().toString())
//console.log("snd pair(3, nil): ", new Application(snd, mypair2).reduce().toString())


function encode (string) {
  var charcodes = mymap(function (a) { return a.charCodeAt(0) - offset; }, string);
  var churchnums = mymap(toChurch, charcodes);
  return myReduceRight(toPair, nil, churchnums)
}

var foo = encode("Hello").reduce()
//console.log("encoded: ", foo.toString())

function decode (church) {
  var res = "";
  var rest = church
  while (rest.toString() != nil.toString()) {
    var cur = new Application(fst, rest).reduce();
    var num = toJS(cur);
    var cha = String.fromCharCode(num + offset);
    res = res.concat(cha);
    rest = new Application(snd, rest).reduce();
  }
  return res;
}

var encodedString = foo.toString();
console.log(encodedString);

var parsed = S(ps(encodedString)).ast

console.log("decoded: ", decode(parsed))
